SHELL=/bin/bash
py3_path=$(shell which python3)
VENV_ON=source venv/bin/activate
REPONAME=$(shell basename $$PWD)
MACRO_ANS_INTER=REPONAME=$(REPONAME) ansible_python_interpreter=$(py3_path) 
DEFAULT_HOST=127.0.0.1
DEFAULT_PROJECT=ongres
DEFAULT_CLIENT=psql
DEFAULT_EPOCH=1
DEFAULT_USER=postgres
DEFAULT_DATABASE=postgres
DEFAULT_PORT=5432
DEFAULT_ANSUSER=root
DEFAULT_TARGET=non-prod
DEFAULT_ENV=xxx
DEFAULT_ACTION=all
DEFAULT_INVENTORY_DIR="../inventories"

API_VERSION=bench-operator.3manuek.com/v1alpha1

ifndef PROJECT
	PROJECT=$(DEFAULT_PROJECT)
endif
ifndef HOST
	HOST=$(DEFAULT_HOST)
endif
ifndef CLI
	CLI=$(DEFAULT_CLIENT)
endif
ifndef EPOCH
	EPOCH=$(DEFAULT_EPOCH)
endif
ifndef USR
	USR=$(DEFAULT_USER)
endif
ifndef DB
	DB=$(DEFAULT_DATABASE)
endif
ifndef PORT
	PORT=$(DEFAULT_PORT)
endif
ifndef ANSUSER
	ANSUSER=$(DEFAULT_ANSUSER)
endif
ifndef TARGET
	TARGET=$(DEFAULT_TARGET)
endif
ifdef DEBUG
	DEBUG=true
endif
ifndef DEBUG
	DEBUG=false
endif

ifndef ENV
	ENV=$(DEFAULT_ENV)
endif

ifndef ACTION
	ACTION=$(DEFAULT_ACTION)
endif

ifndef INVENTORY_DIR
	INVENTORY_DIR=$(DEFAULT_INVENTORY_DIR)
endif

.PHONY: setup venv-install clean-% deploy-%

# Run example
#
# make run USR=pythian_dba TARGET=192.168.0.20

venv-install:
	python3 -m venv venv

setup: venv-install
	$(VENV_ON) && python3 -m pip install --upgrade pip && $(py3_path) -m pip install -r requirements.txt 



run: 
	$(VENV_ON) &&\
	cd playbooks && ANSIBLE_CONFIG="healthcheck.cfg" ansible-playbook $(ansible_debug) \
	-i $(INVENTORY_DIR) --become-user=$(ANSUSER) --ask-become-pass --ask-vault-pass \
	 -e "user=$(USR) port=$(PORT) host=$(HOST) epoch=$(EPOCH) pgai_project=$(PROJECT)" \
		master.yml --limit $(TARGET) -k  --tags $(ACTION)  &&\
	cd .. && deactivate

replica: 
	$(VENV_ON) &&\
	cd playbooks && ANSIBLE_CONFIG="healthcheck.cfg" ansible-playbook $(ansible_debug) \
	-i ../inventories/group_vars/all.yml --ask-become-pass --ask-vault-pass \
	 -e "user=$(USR) database=$(DB) port=$(PORT) host=$(HOST) epoch=$(EPOCH) project=$(PROJECT) $(MACRO_ANS_INTER)" \
		replica.yml --limit $(TARGET) &&\
	cd .. && deactivate

#clean: 
#	$(VENV_ON) &&\
#	cd ansible && ANSIBLE_CONFIG="$(CLI).cfg" ansible-playbook $(ansible_debug) \
#		-i inventories/$(CLI) --extra-vars "DEBUG=$(DEBUG) ansible_state=absent $(MACRO_ANS_INTER) app=$(CLI) version=$(VERSION_EG)" \
#		$(CLI).yml &&\
#	cd .. && deactivate

